//------------------------------------------------------------------
//---- INITIALISATION D'UNE DEMO SUR PC / WIN 32:				----
//----	 														----
//----	- ecran 16bits direct draw								----
//----	- midas player											----
//----															----
//----				Par Deemphasis / UKONX 1999					----
//----					(et internet:)							----
//------------------------------------------------------------------

//	linker avec midasdll.lib ddraw.lib dinput.lib		 
 
//////////////////////////// MIDAS RULEZ! //////////////////////////
 
#include "midasdll.h"
MIDASmodule module;
MIDASmodulePlayHandle playHandle;

///////////////////////////// HEADERS /////////////////////////////

#include "types.h"
#include "fichiers.h"
#include "roto.h"

////////////////////////// MERDIER OINDOZE ////////////////////////

#define WIN32_LEAN_AND_MEAN 
#define INITGUID       // pour le clavier

#include <windows.h>   
#include <windowsx.h> 
#include <mmsystem.h>
#include <objbase.h>

#include <iostream.h>  
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include <math.h>
#include <io.h>
#include <fcntl.h>

#include <ddraw.h>		// directX includes
#include <dinput.h>

//////////////////////// D E F I N E S ////////////////////////////

#define WINDOW_CLASS_NAME "UKONXCLASS"  // class name
#define WINDOW_WIDTH  320        // size of window
#define WINDOW_HEIGHT 200
#define SCREEN_WIDTH  320        // size of screen
#define SCREEN_HEIGHT 200
#define SCREEN_BPP    16         // bits per pixel
 
/////////////////////// P R O T O T Y P E S ///////////////////////

int demo_exit(void);
int directx_init(void);
void getsynchro (unsigned syncInfo, unsigned position, unsigned row);
long getrgbmode(void);

/////////////////////// VARIABLES GOLBALES /////////////////////////

HWND main_window_handle = NULL; // save the window handle
HINSTANCE main_instance = NULL; // save the instance

LPDIRECTDRAW         lpdd         = NULL;  // dd object
LPDIRECTDRAWSURFACE  lpddsprimary = NULL;  // dd primary surface
LPDIRECTDRAWSURFACE  lpddsback    = NULL;  // dd back surface
DDSURFACEDESC        ddsd;                 // a direct draw surface description struct
DDSCAPS              ddscaps;              // a direct draw surface capabilities struct
HRESULT              ddrval;               // result back from dd calls

UWORD                *video_buffer = (UWORD*)NULL; // primary video buffer
UWORD                *double_buffer= (UWORD*)NULL; // double buffer (system RAM)

LPDIRECTINPUT        lpdi;                 // di object
LPDIRECTINPUTDEVICE  lpdikey;              // keyboard device
UCHAR                keystate[256];        // stores keyboard state
				  
LARGE_INTEGER mycount;						// pour la synchro avec le timer
LARGE_INTEGER countfreq; 

#define RGB555 1							// diffrent 16 bits possibles
#define RGB556 2
#define RGB565 3
#define RGB655 4
long rgbmode=0;

////////////////////////////  WindowProc ///////////////////////////////

LRESULT CALLBACK WindowProc(HWND hwnd, 
						    UINT msg, 
                            WPARAM wparam, 
                            LPARAM lparam)
{
	// capture d'evenement (pas trop utilis ici:)
	PAINTSTRUCT	ps;		   // used in WM_PAINT
	HDC			hdc;	   // handle to a device context
	switch(msg)
	{	
		case WM_CREATE: 
		{
			return(0);
		} break;
		case WM_PAINT:
		{
			 // start painting
			 hdc = BeginPaint(hwnd,&ps);
			 // end painting
			 EndPaint(hwnd,&ps);
			 return(0);
		} break;
		case WM_DESTROY: 
		{
			// kill the application			
			PostQuitMessage(0);
			return(0);
		} break;
		default:break;
    } // end switch

	// process any messages that we didn't take care of 
	return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc

//----- en cas de bleme avec midas :

void MIDASerror(void)
{
    printf("MIDAS error: %s\n", MIDASgetErrorMessage(MIDASgetLastError()));
    MIDASclose();
    exit(EXIT_FAILURE);
}

//----- fonction qui peut etre appell par les evenements timers
 
VOID CALLBACK mafonc(
  HWND hwnd,     // handle of window for timer messages
  UINT uMsg,     // WM_TIMER message
  UINT idEvent,  // timer identifier
  DWORD dwTime   // current system time
)

{
	 
}

/////////////////////////////////////////////////////////////////////
//////////////////////// W I N M A I N //////////////////////////////
/////////////////////////////////////////////////////////////////////

int WINAPI WinMain(	HINSTANCE hinstance,
					HINSTANCE hprevinstance,
					LPSTR lpcmdline,
					int ncmdshow)
{
	WNDCLASS winclass;	// this will hold the class we create
	HWND	 hwnd;		// generic window handle
	winclass.style			= CS_DBLCLKS | CS_OWNDC | 
							  CS_HREDRAW | CS_VREDRAW;
	winclass.lpfnWndProc	= WindowProc;
	winclass.cbClsExtra		= 0;
	winclass.cbWndExtra		= 0;
	winclass.hInstance		= hinstance;
	winclass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	winclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
	winclass.hbrBackground	= (struct HBRUSH__ *)GetStockObject(BLACK_BRUSH);
	winclass.lpszMenuName	= NULL; 
	winclass.lpszClassName	= WINDOW_CLASS_NAME;

	// register the window class
	if (!RegisterClass(&winclass))
		return(0);

	// create the window, note the use of WS_POPUP
	if (!(hwnd = CreateWindow(WINDOW_CLASS_NAME, // class
							  "UKONX ENTERPRISE 1999",	 // title
							  WS_POPUP | WS_VISIBLE,
					 		  0,0,	   // x,y
							  WINDOW_WIDTH,  // width
							  WINDOW_HEIGHT, // height
							  NULL,	   // handle to parent 
							  NULL,	   // handle to menu
							  hinstance,// instance
							  NULL)))	// creation parms
				return(0);

	///////////////////////////////////////////////////////////////////
	/////////////////// INITIALISATION OF THE DEMO ////////////////////
	///////////////////////////////////////////////////////////////////

	//////////////////////// MUSIQUE PLEAZzzzz ////////////////////////

    MIDASstartup();
    MIDASsetOption(MIDAS_OPTION_DSOUND_HWND, (DWORD) hwnd);
    MIDASsetOption(MIDAS_OPTION_DSOUND_MODE,MIDAS_DSOUND_PRIMARY);
    if ( !MIDASconfig() )
        return 1;

    if ( !MIDASinit() )
        MIDASerror();

    if ( (module = MIDASloadModule("data/deemphasis.xm")) == NULL )
        MIDASerror();

    if ( (playHandle = MIDASplayModule(module, TRUE)) == 0 )
        MIDASerror();

	////////////////////////////////////////////////////////////////////

	//-------- on vire la souris

	ShowCursor(FALSE);

	//-------- save the window handle and instance in a global

	main_window_handle = hwnd;
	main_instance      = hinstance;

	//-------- ne pas faire de compteur synchro vbl avec ca :  SetTimer(NULL,10,10,(TIMERPROC)mafonc);
 
	//--------  faire plutot : timer hard

	if(!QueryPerformanceCounter(&mycount))		// valeur
		exit(10);

	if(!QueryPerformanceFrequency(&countfreq))	// frequence
		exit(10);
 
	//-------- ouverture ecran dd

	directx_init();

	if(!(rgbmode=getrgbmode()))
		exit(11);

	//-------- start zik
	
	MIDASsetMusicSyncCallback(playHandle,getsynchro);
	MIDASstartBackgroundPlay(20);		// sous interruption
	
	///////////////////////////////////////////////////////////////////
	///////////////////////  deroulement de la demo ///////////////////
	///////////////////////////////////////////////////////////////////

	roto(double_buffer);	 

	///////////////////////////////////////////////////////////////////
	////////////////////////////	FIN		///////////////////////////
	///////////////////////////////////////////////////////////////////

	demo_exit();

	//return(msg.wParam);
	return(0);

} // end WinMain



////////////////////////////////////////////////////////////////////////
//////////////////////// DIRECT X INIT /////////////////////////////////
////////////////////////////////////////////////////////////////////////
  
int directx_init(void)
{
  
	// Set up DirectInput
	if (DirectInputCreate(main_instance,DIRECTINPUT_VERSION,&lpdi,NULL)!=DI_OK)
	  return(0);

	// Create a keyboard device
	if (lpdi->CreateDevice(GUID_SysKeyboard,&lpdikey,NULL)!=DI_OK)
	  return(0);
		
	// Set the cooperation level between DirectX and Windows
	if (lpdikey->SetCooperativeLevel(main_window_handle,
				DISCL_BACKGROUND | DISCL_NONEXCLUSIVE)!=DI_OK)
		 return(0);

	// Set the keyboard data format
	if (lpdikey->SetDataFormat(&c_dfDIKeyboard)!=DI_OK)
	 return(0);

	// Acquire the keyboard
	if (lpdikey->Acquire()!=DI_OK)
	 return(0);

	// Create DirectDraw object and test for error
	if (DirectDrawCreate(NULL,&lpdd,NULL)!=DD_OK)
		 return(0);

	// Set cooperation level 
	if (lpdd->SetCooperativeLevel(main_window_handle,
           DDSCL_ALLOWMODEX | DDSCL_FULLSCREEN | 
           DDSCL_EXCLUSIVE | DDSCL_ALLOWREBOOT)!=DD_OK)
	  return(0);

	// Set the display mode
	if (lpdd->SetDisplayMode(SCREEN_WIDTH,SCREEN_HEIGHT,SCREEN_BPP)!=DD_OK)
		 return(0);

	// Set parameters for the primary surface
	memset(&ddsd,0,sizeof(ddsd));
	ddsd.dwSize         = sizeof(ddsd);
	ddsd.dwFlags        = DDSD_CAPS;
	ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;

	// Create the primary surface!
	if (lpdd->CreateSurface(&ddsd,&lpddsprimary,NULL)!=DD_OK)
		  return(0);

	// Create double buffer in system RAM
	double_buffer = (UWORD *)malloc(320*200*2);

	//-----------------------
	return(1);

}  

//////////////////////////////////////////////////////////////////////
///////////////////////////	DEMO EXIT ////////////////////////////////
//////////////////////////////////////////////////////////////////////

int demo_exit(void)
{
	//---------- stop zik

	if ( !MIDASstopModule(playHandle) )
        MIDASerror();
    if ( !MIDASfreeModule(module) )
        MIDASerror();
    if ( !MIDASclose() )
        MIDASerror();

	// This function is where you shutdown your game and
	// release all resources that you allocated

	// First release the primary surface
	if (lpddsprimary!=NULL)
	   lpddsprimary->Release();
       
	// Release the directdraw object
	if (lpdd!=NULL)
	  lpdd->Release();

	// Un-acquire keyboard
	if (lpdikey!=NULL)
		lpdikey->Unacquire();

	// Release directinput object
	if (lpdi!=NULL)
	  lpdi->Release();	

	// Free up double buffer
	if (double_buffer!=NULL)
		free(double_buffer);
	
	// return success
	return(1);
} // end Game_Shutdown
 
///////////////////////////////////////////////////////////////////////
/////////////  copy to video pour TOUTES les cartes video /////////////
///////////////////////////////////////////////////////////////////////

void rgb15to16(register unsigned short *data,long mode)
{
	#define RGB555 1
	#define RGB556 2
	#define RGB565 3
	#define RGB655 4 

    register long i;
    register unsigned short tamp;
	//register unsigned short r=0,g=0,b=0;

	if (mode==RGB565)
	{
		for(i=0;i<320*200;i++)
		{
		/*	tamp=*data;
			//--------r				
			r=(tamp>>10)&0x1f;	 
			//--------g
			g=(tamp>>5)&0x1f;

			//--------b
			b=tamp&0x1f;	 
			*data=(r<<11)+(g<<6)+b;
			//--------
   			data++;
			//--------b
			*/

			tamp=*data; 
			*data++=((tamp<<1)&0xffc0)+(tamp&0x1f);
		}
	}
	else if (mode==RGB655)
	{
		for(i=0;i<320*200;i++)
		{
			tamp=*data; 
			*data++=((tamp<<1)&0xf800)+(tamp&0x03ff);
		}
	}
	else if (mode==RGB556)
	{
		for(i=0;i<320*200;i++)
		{
			tamp=*data; 
			*data++=(tamp<<1)&0xfffe;
		}
	}
	else if (mode==RGB555)  //rien a faire:)
	{
	}
}

void CopyVideo(UWORD* rgb15)
{
	//////////////////////// check sortie !! /////////////////////////

	// Grab the keyboard state via DirectInput
	lpdikey->GetDeviceState(256,keystate);

	if (keystate[DIK_ESCAPE] & 0x80)
	{
		demo_exit();
		exit(0);
	}
	//  PostMessage(main_window_handle, WM_DESTROY,0,0);

	///////////////////// rgb 15 -> rgb 16 ////////////////////////////

	rgb15to16(rgb15,rgbmode);

	////////////////// affichage de la frame //////////////////////////

	// Tell DirectDraw we are accessing video memory
	lpddsprimary->Lock(NULL,&ddsd,DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT,NULL);

	// Alias a pointer to the surface memory for easy access
	video_buffer = (UWORD *)ddsd.lpSurface;
    
	//lpdd->WaitForVerticalBlank(DDWAITVB_BLOCKBEGIN,0);

	// Copy double buffer into video memory
	memcpy(video_buffer,rgb15,320*200*2);
  
	// Tell DirectDraw we are done accessing video memory
	lpddsprimary->Unlock(ddsd.lpSurface);
}  

//----------- mode 16 bit utilis par la carte video ----------//

long getrgbmode(void)
{
	DDPIXELFORMAT pix;
    pix.dwSize = sizeof( pix );	// hyper important!!!!!!!!!!!!!!!!!
	if(lpddsprimary->GetPixelFormat(&pix)!=DD_OK)
		return 0;
  
	if((pix.dwRBitMask==(0x1f<<10))&&(pix.dwGBitMask==(0x1f<<5))&&(pix.dwBBitMask==0x1f))
		return (RGB555);
	if((pix.dwRBitMask==(0x1f<<11))&&(pix.dwGBitMask==(0x1f<<6))&&(pix.dwBBitMask==0x3f))
		return (RGB556);
	if((pix.dwRBitMask==(0x1f<<11))&&(pix.dwGBitMask==(0x3f<<5))&&(pix.dwBBitMask==0x1f))
		return (RGB565);
	if((pix.dwRBitMask==(0x3f<<10))&&(pix.dwGBitMask==(0x1f<<5))&&(pix.dwBBitMask==0x1f))
		return (RGB655);

	return 0;
}

//////////////////////////////////////////////////////////////////////////////
////////////////////////////  synchro avec xm ////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

int glo_pos=0;
int glo_ligne=0;

void getsynchro (unsigned syncInfo, unsigned position, unsigned row)
{
	glo_pos=position;
	glo_ligne=row;
}

// pour les habitus de digibooster :)

int DBM_CheckPosition(int pos,int ligne)
{
	if(pos>glo_pos)	
		return 0;
	if((pos==glo_pos)&&(ligne>glo_ligne))
		return 0;
	return 1;
}


